"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var openvidu_browser_1 = require("openvidu-browser");
var platform_browser_1 = require("@angular/platform-browser");
var openvidu_appearin_intl_1 = require("../openvidu-appearin-intl");
var StreamAppearinComponent = (function () {
    function StreamAppearinComponent(domSanitizer, renderer, _intl) {
        this.domSanitizer = domSanitizer;
        this.renderer = renderer;
        this._intl = _intl;
        this.onSourceAdded = new core_1.EventEmitter();
    }
    Object.defineProperty(StreamAppearinComponent.prototype, "stream", {
        get: function () { return this._stream; },
        set: function (val) {
            var _this = this;
            if (val === null || val === undefined)
                return;
            this._stream = val;
            // Loop until you get a WrStream
            var int = setInterval(function () {
                if (_this.stream.getWrStream()) {
                    _this.videoSrc = _this.domSanitizer.bypassSecurityTrustUrl(URL.createObjectURL(_this.stream.getWrStream()));
                    console.log('Video tag src = ' + _this.videoSrc);
                    clearInterval(int);
                    // Fix: manually call OnInit
                    _this.ngOnInit();
                }
            }, 1000);
            // If local, mute video
            this.muted = this.stream.isLocalMirrored();
            // If local, flip screen
            this.renderer.setElementClass(this.videoStream.nativeElement, 'flip-screen', this.stream.isLocalMirrored());
            // If local, show nice name
            var dataObj = JSON.parse(this.stream.getParticipant().data);
            this.name.nativeElement.textContent = (this.stream.isLocalMirrored()) ? this._intl.you : dataObj.username;
        },
        enumerable: true,
        configurable: true
    });
    StreamAppearinComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.videoStream.nativeElement.addEventListener('loadeddata', function () {
            // Emit event
            _this.onSourceAdded.emit();
        }, false);
        if (!this.stream)
            return;
        // Listen for changes in the src
        // For example, if the participants wants to change camera
        this.stream.addEventListener('src-added', function () {
            _this.videoSrc = _this.domSanitizer.bypassSecurityTrustUrl(URL.createObjectURL(_this.stream.getWrStream()));
        });
    };
    return StreamAppearinComponent;
}());
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], StreamAppearinComponent.prototype, "onSourceAdded", void 0);
__decorate([
    core_1.ViewChild('name'),
    __metadata("design:type", core_1.ElementRef)
], StreamAppearinComponent.prototype, "name", void 0);
__decorate([
    core_1.ViewChild('videoStream'),
    __metadata("design:type", core_1.ElementRef)
], StreamAppearinComponent.prototype, "videoStream", void 0);
__decorate([
    core_1.Input('stream'),
    __metadata("design:type", openvidu_browser_1.Stream),
    __metadata("design:paramtypes", [openvidu_browser_1.Stream])
], StreamAppearinComponent.prototype, "stream", null);
StreamAppearinComponent = __decorate([
    core_1.Component({
        selector: 'stream-appearin',
        styles: ["\n   .flip-screen {\n     -webkit-transform: scaleX(-1);\n         -ms-transform: scaleX(-1);\n             transform: scaleX(-1); }\n\n   stream-appearin {\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex; }\n     stream-appearin .participant {\n       -webkit-box-flex: 1;\n       -webkit-flex: 1;\n           -ms-flex: 1;\n               flex: 1;\n       width: 100%;\n       background-color: rgba(0, 0, 0, 0.4);\n       display: -webkit-box;\n       display: -webkit-flex;\n       display: -ms-flexbox;\n       display: flex;\n       -webkit-box-orient: vertical;\n       -webkit-box-direction: normal;\n       -webkit-flex-direction: column;\n           -ms-flex-direction: column;\n               flex-direction: column;\n       -webkit-box-pack: center;\n       -webkit-justify-content: center;\n           -ms-flex-pack: center;\n               justify-content: center;\n       -webkit-box-align: center;\n       -webkit-align-items: center;\n           -ms-flex-align: center;\n               align-items: center; }\n       stream-appearin .participant span {\n         color: #fff;\n         display: none; }\n       stream-appearin .participant video {\n         width: 100%;\n         height: 100%; }\n\t"],
        template: "\n\t\t<div class=\"participant\">\n\t\t\t<span #name></span>\n\t\t\t<video #videoStream autoplay=\"true\" [src]=\"videoSrc\" [muted]=\"muted\"></video>\n        </div>",
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [platform_browser_1.DomSanitizer, core_1.Renderer,
        openvidu_appearin_intl_1.OpenViduAppearinIntl])
], StreamAppearinComponent);
exports.StreamAppearinComponent = StreamAppearinComponent;
