"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
// OpenVidu Hanguts i18n
var openvidu_hangouts_intl_1 = require("../openvidu-hangouts-intl");
var DialogHangoutsComponent = (function () {
    function DialogHangoutsComponent(dialogRef, _intl) {
        this.dialogRef = dialogRef;
        this._intl = _intl;
        this.videoInputs = [];
    }
    DialogHangoutsComponent.prototype.ngOnInit = function () {
        var _this = this;
        var that = this;
        navigator.mediaDevices.enumerateDevices().then(function (deviceInfos) {
            that.gotDevices(deviceInfos);
        }).catch(function (error) {
            _this.handleError(error);
        });
    };
    DialogHangoutsComponent.prototype.onSubmit = function () {
        this.dialogRef.close(this.selectedVideoInput);
    };
    DialogHangoutsComponent.prototype.gotDevices = function (deviceInfos) {
        for (var _i = 0, deviceInfos_1 = deviceInfos; _i < deviceInfos_1.length; _i++) {
            var deviceInfo = deviceInfos_1[_i];
            /*if (deviceInfo.kind === 'audioinput') {
                option.text = deviceInfo.label ||
                     'microphone ' + (audioInputSelect.length + 1);
                audioInputSelect.appendChild(option);
            } else if (deviceInfo.kind === 'audiooutput') {
                option.text = deviceInfo.label || 'speaker ' +
                     (audioOutputSelect.length + 1);
                audioOutputSelect.appendChild(option);
            } else*/
            if (deviceInfo.kind === 'videoinput') {
                this.videoInputs.push({
                    label: deviceInfo.label || 'WebCam ' + (this.videoInputs.length + 1),
                    deviceId: deviceInfo.deviceId,
                });
            }
            else {
                console.log('Some other kind of source/device: ', deviceInfo);
            }
        }
    };
    DialogHangoutsComponent.prototype.handleError = function (error) {
        console.log('navigator.getUserMedia error: ', error);
    };
    return DialogHangoutsComponent;
}());
DialogHangoutsComponent = __decorate([
    core_1.Component({
        selector: 'dialog-hangouts',
        template: "\n   <md-tab-group>\n   \t<md-tab label=\"General\">\n   \t\t<form>\n   \t\t\t<div>\n   \t\t\t\t<label>{{_intl.selectVideoInputLabel}}</label>\n   \t\t\t</div>\n   \t\t\t<div>\n   \t\t\t\t<md-select placeholder=\"Video input\" [(ngModel)]=\"selectedVideoInput\" name=\"videoInput\">\n   \t\t\t\t\t<md-option *ngFor=\"let video of videoInputs\" [value]=\"video.deviceId\">\n   \t\t\t\t\t\t{{video.label}}\n   \t\t\t\t\t</md-option>\n   \t\t\t\t</md-select>\n   \t\t\t</div>\n   \t\t\t<div>\n   \t\t\t\t<button md-raised-button (click)=\"onSubmit()\">{{_intl.readyLabel}}</button>\n   \t\t\t</div>\n   \t\t</form>\n   \t</md-tab>\n   </md-tab-group>\n\t",
    }),
    __metadata("design:paramtypes", [material_1.MdDialogRef,
        openvidu_hangouts_intl_1.OpenViduHangoutsIntl])
], DialogHangoutsComponent);
exports.DialogHangoutsComponent = DialogHangoutsComponent;
