"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var openvidu_browser_1 = require("openvidu-browser");
var platform_browser_1 = require("@angular/platform-browser");
var openvidu_hangouts_intl_1 = require("../openvidu-hangouts-intl");
var StreamHangoutsComponent = (function () {
    function StreamHangoutsComponent(domSanitizer, renderer, _intl) {
        this.domSanitizer = domSanitizer;
        this.renderer = renderer;
        this._intl = _intl;
        this.onSourceAdded = new core_1.EventEmitter();
        // Input
        this.micEnabled = false;
        this.camEnabled = false;
    }
    Object.defineProperty(StreamHangoutsComponent.prototype, "stream", {
        get: function () { return this._stream; },
        set: function (val) {
            var _this = this;
            if (val === null || val === undefined)
                return;
            this._stream = val;
            // Loop until you get a WrStream
            var int = setInterval(function () {
                if (_this.stream.getWrStream()) {
                    _this.videoSrc = _this.domSanitizer.bypassSecurityTrustUrl(URL.createObjectURL(_this.stream.getWrStream()));
                    console.log('Video tag src = ' + _this.videoSrc);
                    clearInterval(int);
                    // Fix: manually call OnInit
                    _this.ngOnInit();
                }
            }, 1000);
            // If local, mute video
            this.muted = this.stream.isLocalMirrored();
            // If local, flip screen
            this.renderer.setElementClass(this.videoStream.nativeElement, 'flip-screen', this.stream.isLocalMirrored());
            // If local, show nice name
            var dataObj = JSON.parse(this.stream.getParticipant().data);
            this.name.nativeElement.textContent = (this.stream.isLocalMirrored()) ? this._intl.you : dataObj.username;
        },
        enumerable: true,
        configurable: true
    });
    StreamHangoutsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.videoStream.nativeElement.addEventListener('loadeddata', function () {
            // Emit event
            _this.onSourceAdded.emit();
        }, false);
        if (!this.stream)
            return;
        // Listen for changes in the src
        // For example, if the participants wants to change camera
        this.stream.addEventListener('src-added', function () {
            _this.videoSrc = _this.domSanitizer.bypassSecurityTrustUrl(URL.createObjectURL(_this.stream.getWrStream()));
        });
    };
    return StreamHangoutsComponent;
}());
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], StreamHangoutsComponent.prototype, "onSourceAdded", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], StreamHangoutsComponent.prototype, "micEnabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], StreamHangoutsComponent.prototype, "camEnabled", void 0);
__decorate([
    core_1.ViewChild('name'),
    __metadata("design:type", core_1.ElementRef)
], StreamHangoutsComponent.prototype, "name", void 0);
__decorate([
    core_1.ViewChild('videoStream'),
    __metadata("design:type", core_1.ElementRef)
], StreamHangoutsComponent.prototype, "videoStream", void 0);
__decorate([
    core_1.Input('stream'),
    __metadata("design:type", openvidu_browser_1.Stream),
    __metadata("design:paramtypes", [openvidu_browser_1.Stream])
], StreamHangoutsComponent.prototype, "stream", null);
StreamHangoutsComponent = __decorate([
    core_1.Component({
        selector: 'stream-hangouts',
        styles: ["\n   .flip-screen {\n     -webkit-transform: scaleX(-1);\n         -ms-transform: scaleX(-1);\n             transform: scaleX(-1); }\n\n   stream-hangouts.main-stream .participant {\n     width: 100%;\n     height: 100%;\n     margin: 0px;\n     float: none;\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex; }\n     stream-hangouts.main-stream .participant .name {\n       display: none; }\n     stream-hangouts.main-stream .participant video {\n       width: 100%; }\n\n   stream-hangouts.square .participant {\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex;\n     -webkit-box-pack: center;\n     -webkit-justify-content: center;\n         -ms-flex-pack: center;\n             justify-content: center;\n     width: 100px;\n     overflow: hidden; }\n     stream-hangouts.square .participant .name {\n       text-align: center;\n       top: 45px;\n       white-space: normal;\n       word-break: break-all; }\n     stream-hangouts.square .participant video {\n       width: auto; }\n\n   stream-hangouts.hide-video .participant .name {\n     text-align: center;\n     top: 45px;\n     white-space: normal;\n     word-break: break-all; }\n\n   stream-hangouts.hide-video .participant video {\n     display: none; }\n\n   stream-hangouts .participant {\n     position: relative;\n     width: 177px;\n     height: 100px;\n     -webkit-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.4);\n             box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.4);\n     background-color: rgba(0, 0, 0, 0.4); }\n     stream-hangouts .participant .name {\n       position: absolute;\n       bottom: 10px;\n       text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1; }\n     stream-hangouts .participant .mic-off {\n       position: absolute;\n       bottom: 10px;\n       text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1;\n       text-align: center;\n       background: rgba(0, 0, 0, 0.5);\n       border-radius: 50%;\n       width: 26px;\n       height: 26px;\n       padding: 4px;\n       right: 5px; }\n     stream-hangouts .participant .cam-off {\n       position: absolute;\n       text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1;\n       text-align: center;\n       background: rgba(0, 0, 0, 0.5);\n       border-radius: 50%;\n       width: 26px;\n       height: 26px;\n       padding: 4px;\n       top: 10px;\n       right: 5px; }\n     stream-hangouts .participant video {\n       width: 100%;\n       height: 100%; }\n\t"],
        template: "\n\t\t<div class=\"participant\">\n\t\t\t<span #name class=\"name\"></span>\n\t\t\t\n\t\t\t<!--<span class=\"mic-off\" [hidden]=\"micEnabled\"><md-icon>mic_off</md-icon></span>\n\t\t\t<span class=\"cam-off\" [hidden]=\"camEnabled\"><md-icon>videocam_off</md-icon></span>-->\n\t\t\t\n\t\t\t<video #videoStream autoplay=\"true\" [src]=\"videoSrc\" [muted]=\"muted\"></video>\n        </div>",
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [platform_browser_1.DomSanitizer, core_1.Renderer,
        openvidu_hangouts_intl_1.OpenViduHangoutsIntl])
], StreamHangoutsComponent);
exports.StreamHangoutsComponent = StreamHangoutsComponent;
