"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var testing_1 = require("@angular/core/testing");
// Imports dependencies of component to be tested
var openvidu_module_1 = require("./openvidu.module");
// Component to be tested
var openvidu_directive_1 = require("./openvidu.directive");
// Testing utils
var testing_helper_1 = require("./testing/testing-helper");
var TestComponent = (function () {
    function TestComponent() {
    }
    TestComponent.prototype.onServerConnected = function () {
        // Dummy
    };
    TestComponent.prototype.onRoomConnected = function () {
        // Dummy
    };
    TestComponent.prototype.onParticipantJoined = function () {
        // Dummy
    };
    TestComponent.prototype.onParticipantLeft = function () {
        // Dummy
    };
    TestComponent.prototype.onErrorMedia = function () {
        // Dummy
    };
    TestComponent.prototype.onLeaveRoom = function () {
        // Dummy
    };
    TestComponent.prototype.onNewMessage = function () {
        // Dummy
    };
    return TestComponent;
}());
__decorate([
    core_1.ViewChild('openviduApi'),
    __metadata("design:type", openvidu_directive_1.OpenViduDirective)
], TestComponent.prototype, "openviduApi", void 0);
TestComponent = __decorate([
    core_1.Component({
        template: "\n\t<openvidu-template\n\t\t#openviduApi=\"openviduApi\"\n\t\t[wsUrl]=\"wsUrl\" [sessionId]=\"sessionId\" [participantId]=\"participantId\"\n\t\t(onServerConnected)=\"onServerConnected()\"\n\t\t(onRoomConnected)=\"onRoomConnected()\"\n\t\t(onParticipantJoined)=\"onParticipantJoined($event)\"\n\t\t(onParticipantLeft)=\"onParticipantLeft($event)\"\n\t\t(onErrorMedia)=\"onErrorMedia()\"\n\t\t(onLeaveRoom)=\"onLeaveRoom()\"\n\t\t(onNewMessage)=\"onNewMessage($event)\">\n\t\tLoading openvidu...\n\t</openvidu-template>"
    })
], TestComponent);
describe('AngularOpenVidu Directive', function () {
    var fixture;
    var testComponent;
    var defaultWsUrl = 'wss://127.0.0.1:8443/';
    beforeEach(testing_1.async(function () {
        // Setup the component to be tested
        testing_1.TestBed.configureTestingModule({
            imports: [
                openvidu_module_1.OpenViduModule
            ],
            declarations: [
                TestComponent
            ],
            providers: [
                { provide: testing_1.ComponentFixtureAutoDetect, useValue: true }
            ]
        })
            .compileComponents().then(function () {
            fixture = testing_1.TestBed.createComponent(TestComponent);
            fixture.detectChanges();
            testComponent = fixture.componentInstance;
        });
    }));
    afterEach(function () {
        // Reset the testing module
        //getTestBed().resetTestingModule();
    });
    it('should create the component', function () {
        // Check that the componente has been instanciated
        expect(testComponent).toBeTruthy();
    });
    it('should trigger ngOnChanges', function () {
        // Setup spy
        spyOn(testComponent.openviduApi, 'ngOnChanges').and.callThrough();
        // No calls
        expect(testComponent.openviduApi.ngOnChanges).not.toHaveBeenCalled();
        // One call
        testComponent.sessionId = 'dummy';
        fixture.detectChanges();
        expect(testComponent.openviduApi.ngOnChanges).toHaveBeenCalled();
        // Check values
        var sessionId = 'SessionA';
        testComponent.sessionId = sessionId;
        var participantId = 'ParticipantA';
        testComponent.participantId = participantId;
        var wsUrl = 'wss://127.0.0.1:8443/';
        testComponent.wsUrl = wsUrl;
        fixture.detectChanges();
        expect(testComponent.openviduApi.sessionId).toEqual(sessionId);
        expect(testComponent.openviduApi.participantId).toEqual(participantId);
        expect(testComponent.openviduApi.wsUrl).toEqual(wsUrl);
    });
    it('should trigger onServerConnected', function (done) {
        console.log(testComponent.openviduApi.wsUrl);
        // Setup spy
        var spyChanges = spyOn(testComponent, 'onServerConnected').and.callThrough();
        // setup creds
        var randomCredentials = testing_helper_1.getRandomCredentials();
        testComponent.sessionId = randomCredentials['sessionId'];
        testComponent.participantId = randomCredentials['participantId'];
        testComponent.wsUrl = defaultWsUrl;
        // Check trigger
        //setTimeout(() => {
        //	expect(spyChanges).toHaveBeenCalled();
        //	done();
        //}, 1000);
        done();
        expect(true).toBeTruthy();
    });
    it('should trigger onRoomConnected', function () {
        // Setup spy
        var spyChanges = spyOn(testComponent, 'onRoomConnected').and.callThrough();
        // setup creds
        var randomCredentials = testing_helper_1.getRandomCredentials();
        testComponent.sessionId = randomCredentials['sessionId'];
        testComponent.participantId = randomCredentials['participantId'];
        testComponent.wsUrl = defaultWsUrl;
        // Check trigger
        //expect(spyChanges).toHaveBeenCalled();
        expect(true).toBeTruthy();
    });
    it('should trigger onParticipantJoined', function () {
        expect(true).toBeTruthy();
    });
    it('should trigger onParticipantLeft', function () {
        expect(true).toBeTruthy();
    });
    it('should trigger onErrorMedia', function () {
        expect(true).toBeTruthy();
    });
    it('should trigger onLeaveRoom', function () {
        expect(true).toBeTruthy();
    });
    it('should trigger onNewMessage', function () {
        expect(true).toBeTruthy();
    });
    //const h2 = fixture.debugElement.query(By.css('h2'));
    //expect(h2.nativeElement.textContent).to.equal('Value: 0'
});
