"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Base Modules
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
// Angular Material
var animations_1 = require("@angular/platform-browser/animations");
var material_1 = require("@angular/material");
// OpenVidu logic for custom template
var openvidu_directive_1 = require("./openvidu.directive");
// OpenVidu Hangouts
var openvidu_hangouts_intl_1 = require("./openvidu-hangouts/openvidu-hangouts-intl");
var dialog_hangouts_component_1 = require("./openvidu-hangouts/dialog-hangouts/dialog-hangouts.component");
var stream_hangouts_component_1 = require("./openvidu-hangouts/stream-hangouts/stream-hangouts.component");
var openvidu_hangouts_component_1 = require("./openvidu-hangouts/openvidu-hangouts.component");
// OpenVidu Appearin
var openvidu_appearin_intl_1 = require("./openvidu-appearin/openvidu-appearin-intl");
var stream_appearin_component_1 = require("./openvidu-appearin/stream-appearin/stream-appearin.component");
var openvidu_appearin_component_1 = require("./openvidu-appearin/openvidu-appearin.component");
// OpenVidu GoToMeeting
var openvidu_gotomeeting_intl_1 = require("./openvidu-gotomeeting/openvidu-gotomeeting-intl");
var stream_gotomeeting_component_1 = require("./openvidu-gotomeeting/stream-gotomeeting/stream-gotomeeting.component");
var openvidu_gotomeeting_component_1 = require("./openvidu-gotomeeting/openvidu-gotomeeting.component");
// Fullscreen Service
var angular_bigscreen_1 = require("angular-bigscreen");
// ObjNgFor Pipe
var objngfor_pipe_1 = require("./utils/objngfor-pipe");
// SplitPane Module
var ng2_split_pane_1 = require("ng2-split-pane/lib/ng2-split-pane");
var OpenViduModule = (function () {
    function OpenViduModule() {
    }
    return OpenViduModule;
}());
OpenViduModule = __decorate([
    core_1.NgModule({
        imports: [
            common_1.CommonModule,
            forms_1.FormsModule,
            /* Material Module */
            animations_1.NoopAnimationsModule,
            material_1.MdButtonModule,
            material_1.MdDialogModule,
            material_1.MdIconModule,
            material_1.MdInputModule,
            material_1.MdSelectModule,
            material_1.MdSidenavModule,
            material_1.MdToolbarModule,
            material_1.MdTooltipModule,
            /* SpliPane Module */
            ng2_split_pane_1.SplitPaneModule
        ],
        declarations: [
            /* OpenVidu Directive */
            openvidu_directive_1.OpenViduDirective,
            /* OpenVidu Hangouts */
            dialog_hangouts_component_1.DialogHangoutsComponent,
            stream_hangouts_component_1.StreamHangoutsComponent,
            openvidu_hangouts_component_1.OpenViduHangoutsComponent,
            /* OpenVidu Appearin */
            stream_appearin_component_1.StreamAppearinComponent,
            openvidu_appearin_component_1.OpenViduAppearinComponent,
            /* OpenVidu GoToMeeting */
            stream_gotomeeting_component_1.StreamGoToMeetingComponent,
            openvidu_gotomeeting_component_1.OpenViduGoToMeetingComponent,
            /* ObjNgFor Pipe */
            objngfor_pipe_1.ObjNgForPipe
        ],
        exports: [
            /* OpenVidu Directive */
            openvidu_directive_1.OpenViduDirective,
            /* OpenVidu Hangouts */
            openvidu_hangouts_component_1.OpenViduHangoutsComponent,
            /* OpenVidu Appearin */
            openvidu_appearin_component_1.OpenViduAppearinComponent,
            /* OpenVidu GoToMeeting */
            openvidu_gotomeeting_component_1.OpenViduGoToMeetingComponent
        ],
        providers: [
            /* OpenVidu Hangouts i18n */
            openvidu_hangouts_intl_1.OpenViduHangoutsIntl,
            /* OpenVidu Appearin i18n */
            openvidu_appearin_intl_1.OpenViduAppearinIntl,
            /* OpenVidu GoToMeeting i18n */
            openvidu_gotomeeting_intl_1.OpenViduGoToMeetingIntl,
            /* Fullscreen Service */
            angular_bigscreen_1.BigScreenService
        ],
        entryComponents: [
            /* OpenVidu Hangouts Aux. Component */
            dialog_hangouts_component_1.DialogHangoutsComponent
        ]
    })
], OpenViduModule);
exports.OpenViduModule = OpenViduModule;
